%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This program is coded by Hyun-Chul Choi
% For Christine Seul Ki Kim
% initiated on 2014.01.20
% updated on 2014.08.10
% updated on 2015.05.23
% last updated on 2015.07.17
% copyright@Hyun-Chul Choi
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%close all;
clear all;
clc;

% step1. prepair your images in a folder
% step2. make a new folder to save the result image files
% step3. change "image_folder_name" variable into your image folder
% step4. change "result_folder_name" variable into the result folder
% step5. change "width_length" variable into the exact scale (real length/pixel)
% step6. if you have some labeling on the top or bottom region of image,
% then you can set "offset" and "offset_reverse" to eliminate the labeled
% region to avoid unexpected error.
% step7. select number of subregions > 16. If you want smooth boundaries, then
% set "sub_num" variable high value.
% step8. run this m-file
% step9. check the result images in the result folder.
% step10. open "result_list.txt" in the result folder. Then, you can find
% the height of subregions and the average heights of the bands of your
% images.
% If you want to get more tight boundaries, then set "level_scale" higher
% vale.

image_folder_name = 'images';           % image folder name: image files only in this folder
result_folder_name = 'images-results';  % result folder name: make folder before you run this program

width_length = 145; % scale bar
offset = 0;         % height in pixels to eliminate scale bar from the top 
offset_reverse = 0; % height in pixels to eliminate scale bar from the bottom 
sub_num = 32;       % number of subregions: the more subregions you use, the smoother boundaries you can get.
level_scale = 1.5;  % the scale of Otsu threshold: set higher for tight boundaries.
threshold = 0.5;    % threhold for bipolarizing
initial_effective_ratio = 0.6;  % effective ratio of subregions
T1 = 0.3;           % difference threshold
T2 = 30;            % absolute threshold

image_analysis(image_folder_name, result_folder_name, width_length, offset, offset_reverse, sub_num, threshold, initial_effective_ratio, T1, T2, level_scale);